

//      (Buy, Sell)  ,  
//     .    /   
//   12  (  )  High/Low     
// . 
// 
//      R1   ATR 
//     SMA * kof
// : 
//-----         
// 2.period_Teni  -        . 
//-----         
// 3.spred   -    ,  . 
//----- 
// 4.min_order -          
//                .  
// 5.koef_ATR     =    1.5;  
//-----         
// 6.text    -   "true",         
//                    
//               (  ). 
//***********************************************************************************/

#property indicator_chart_window 

#property indicator_buffers       6         
#property indicator_color1        Green  
#property indicator_color2        Red  
#property indicator_color3        Gray
#property indicator_color4        Gray  
#property indicator_color5        DarkSlateGray 
#property indicator_color6        DarkSlateGray

//-----     
extern int    period_Teni     =     12;
extern int     period_ATR     =     12;  
extern double   min_order     =     0;   
extern double      koef_R     =    1.5;  
extern bool          text     =   false; 
       double       spred; 
  
//-----         
double Buf_Order_Buy[], 
       Buf_Order_Sel[],
       Buf_Stop_Buy[],
       Buf_Stop_Sel[],
       Buf_R_1_Buy[],
       Buf_R_1_Sel[]; 
//+===========================================================================+ 
int init() 
   { 
     SetIndexBuffer (0, Buf_Order_Buy); 
     SetIndexStyle  (0, DRAW_ARROW); 
     SetIndexArrow  (0, 159); 
     SetIndexLabel  (0,"Order_Buy");
    //-----         
     SetIndexBuffer (1, Buf_Order_Sel);  
     SetIndexStyle  (1, DRAW_ARROW); 
     SetIndexArrow  (1, 159); 
     SetIndexLabel  (1,"Order_Sell");
     
     SetIndexBuffer (2, Buf_Stop_Buy); 
     SetIndexStyle  (2, DRAW_ARROW); 
     SetIndexArrow  (2, SYMBOL_STOPSIGN); 
     SetIndexLabel  (2,"Stop_Buy");
    //-----         
     SetIndexBuffer (3, Buf_Stop_Sel);  
     SetIndexStyle  (3, DRAW_ARROW); 
     SetIndexArrow  (3, SYMBOL_STOPSIGN); 
     SetIndexLabel  (3,"Stop_Sell");
     
     SetIndexBuffer (4, Buf_R_1_Buy);  
     SetIndexStyle  (4, DRAW_LINE, STYLE_DOT); 
     SetIndexLabel  (4,"Profit_Buy");
     
     SetIndexBuffer (5, Buf_R_1_Sel);  
     SetIndexStyle  (5, DRAW_LINE, STYLE_DOT); 
     SetIndexLabel  (5,"Profit_Sell");
     
     IndicatorDigits(Digits);
    spred = (MarketInfo(Symbol(),MODE_SPREAD))*Point;  //---  .
    min_order*=10;
     
    return(0); 
   } 
//+===========================================================================+ 
int start() 
   { 
    int ounted_bars=IndicatorCounted();
    if (ounted_bars<=period_Teni) int limit=Bars-period_Teni-1;
    if (ounted_bars>period_Teni) limit=Bars-ounted_bars-1;
    int i=limit;
    int n = 0;
    
       
   
     while (i >= 0){ 
           //-------------------------------------------------------------------------
           double V_Pos = 0, //      
                  V_Neg = 0; //      
           //--------------    --------------------
            for (n = i; n < i + period_Teni; n++) //   21.04.2010
            
                { 
                   if (Close[n] > Open[n]) V_Pos = V_Pos + (High [n] - Close[n]); 
                   else                    V_Pos = V_Pos + (High [n] - Open [n]);     
               
                   if (Close[n] < Open[n]) V_Neg = V_Neg + (Close[n] - Low  [n]); 
                   else                    V_Neg = V_Neg + (Open [n] - Low  [n]);     
                } 

           //------------  -------------------         
            double Order_Buy = High[i] + (V_Pos / period_Teni) + spred, 
                   Order_Sel = Low[i]  - (V_Neg / period_Teni),
                   ATR = iATR(NULL,0,period_ATR,i), R = ATR * koef_R,
                   Stop_Buy = 0, Stop_Sel = 0, R_1_Buy = 0, R_1_Sel = 0;  
           //-------------  -----------------------
             
            if (Order_Buy < High[i] + min_order * Point + spred)  
                Order_Buy = High[i] + min_order * Point + spred;
           //-----  
            if (Order_Sel > Low[i]  - min_order * Point)  
                Order_Sel = Low[i]  - min_order * Point; 
           //------------ -------------------            
            Stop_Buy = Order_Buy - R;
            Stop_Sel = Order_Sel + R + spred;
           //------------  R_1-------------------        
            R_1_Buy = Order_Buy + R; 
            R_1_Sel = Order_Sel - R + spred;
            
                        
            //-----  
            if (text) // ,    
             
                Comment ("  :","\n", 
                         " BUY = ",DoubleToStr(Buf_Order_Buy[1],Digits),"\n", //    
                         " SELL = ",DoubleToStr(Buf_Order_Sel[1],Digits),"\n",
                         " Buy = ",DoubleToStr(Buf_Stop_Buy[1],Digits),"\n",
                         " Sel = ",DoubleToStr(Buf_Stop_Sel[1],Digits),"\n",
                         "R1 Buy = ",DoubleToStr(Buf_R_1_Buy[1],Digits),"\n",
                         "R1 Sel = ",DoubleToStr(Buf_R_1_Sel[1],Digits),"\n"); 
           //----- 
           Buf_Order_Buy[i]= Order_Buy; 
           Buf_Order_Sel[i]= Order_Sel;
           Buf_Stop_Buy[i]= Stop_Buy;
           Buf_Stop_Sel[i]= Stop_Sel;
           Buf_R_1_Buy[i]= R_1_Buy;
           Buf_R_1_Sel[i]= R_1_Sel; 
           i--; 
          }
          
   return(0); 
   } 
//+===========================================================================+  



